;
;=======================================
;===                                 ===
;=== Runtime Routine for H8SPAS      ===
;===  sep 19 '96  by @ ( rtr5.asm )  ===
;===                                 ===
;=======================================
;*
;* nov 6 '01 SCI3R modified
;* -------------------------------------
;* aug. 24 '05...for h8/3052
;* apr.  8 '08...for h8/3052 SDC
;*
;=================================
;==  ( public )                 ==
;==  aux rcv interrupt          ==
;==                             ==
;=================================
;*
;* procedure rxi1int; interrupt; { hardware interrupt }
;*
rxi1int:mov.l	r0,@-sp
	mov.l	r1,@-sp
	mov.l	r2,@-sp
;/;
;/; debug
;/;
;/	mov.b	p6dr,r0
;/	add.b	#1,r0
;/	and.b	#h'03,r0
;/	mov.b	r0,p6dr		; debug
; data:=rdr1 and $7f;         { strip parity }
	mov.b	sci1rdr,r0
	and.w	#h'7f,r0
; ssr1:=stat and $80;         { clr rxrdy }
	mov.b	sci1ssr,r1
	mov.b	r1,r2
	and.b	#h'87,r1
	mov.b	r1,sci1ssr
	and.b	#h'38,r2
	beq	$1
	bset	#7,r0		; OE,FE,PE !
;
; LF --> not save, CR --> CR,LF save
;
$1:	cmp.b	#h'0a,r0
	beq	$3		; not save
	cmp.b	#h'0d,r0
	bne	$2
	bsr	putbuf1
	mov.b	#h'0a,r0
$2:	bsr	putbuf1
; end; {rxi1int}
$3:	mov.l	@sp+,r2
	mov.l	@sp+,r1
	mov.l	@sp+,r0
	rte
;
;=================================
;==  ( i/o )                    ==
;==  put buf1                   ==
;==                             ==
;=================================
;*
;* in...r0.w = data
;*
putbuf1:mov.l	r0,@-sp
	mov.l	r1,@-sp
; rcvbuf[putrcvp]:=data;
	mov.l	putrcvp1,r1
	mov.b	r0,@(rcvbuf1,r1)
; putrcvp:=putrcvp+1;
	inc.l	#1,r1
; if putrcvp=rbufsiz then putrcvp:=0;
	cmp.l	#rbufsiz,r1
	bne	$3
	xor.l	r1,r1
$3:	mov.l	r1,putrcvp1
; rcvcnt:=rcvcnt+1;
	mov.w	rcvcnt1,r0
	inc.w	#1,r0
	mov.w	r0,rcvcnt1
;
; owari
;
	mov.l	@sp+,r1
	mov.l	@sp+,r0
	rts
;
;=================================
;==  ( i/o )                    ==
;==  get aux1 size              ==
;==                             ==
;=================================
;*
;* func aux1siz: integer;
;*
aux1siz:mov.w	rcvcnt1,r0
	rts
;
;=================================
;==  ( i/o )                    ==
;==  get auxbuf 1               ==
;==                             ==
;=================================
;*
;* func chin1(var dv:devtbl): char;
;* out...r0.w = data
;*
chin1:	mov.l	fp,@-sp
	mov.l	sp,fp
; repeat until rcvcnt1<>0
$1:	mov.w	rcvcnt1,r1
	beq	$1
; reg.r0:=rcvbuf1[getrcvp1]
	mov.l	getrcvp1,r1
	mov.b	@(rcvbuf1,r1),r0
	and.w	#h'7f,r0
; getrcvp1:=getrcvp1+1
	inc.l	#1,r1
; if getrcvp1=rbufsiz then getrcvp1:=0
	cmp.l	#rbufsiz,r1
	bne	$2
	xor.l	r1,r1
$2:	mov.l	r1,getrcvp1
; rcvcnt1:=rcvcnt1-1
	stc.w	ccr,@-sp
	ldc.b	#h'c0,ccr		; di
	mov.w	rcvcnt1,r1
	dec.w	#1,r1
	mov.w	r1,rcvcnt1
	ldc.w	@sp+,ccr
; end; {chin}
	mov.l	fp,sp
	mov.l	@sp+,fp
	mov.l	@sp+,r1		; ret addr
	adds	#4,sp
	jmp	@r1
;
;=================================
;==  ( i/o )                    ==
;==  send aux1                  ==
;==                             ==
;=================================
;*
;* proc chout1(ch:char; var dv:devtbl);
;*
;* in...tos.l = device addr
;*      2nd.w = ch
;*
chout1:	mov.l	fp,@-sp
	mov.l	sp,fp
; repeat until sci1ssr.tdre<>0; { wait until TDRE }
$2:	mov.b	sci1ssr,r1
	btst	#7,r1
	beq	$2
; sci1.tdr:=reg.r0;
	mov.w	@(12,fp),r0
	mov.b	r0,sci1tdr
; sci1ssr.tdre:=0;
	bclr	#7,r1
	mov.b	r1,sci1ssr
; end; {sci1s}
	mov.l	fp,sp
	mov.l	@sp+,fp
	mov.l	@sp+,r1		; ret addr
	add.l	#6,sp
	jmp	@r1
;
;=================================
;==  ( public )                 ==
;==  sci1 initialize            ==
;==                             ==
;=================================
;* 
;* procedure sci1ini(bps: integer);
;*
sci1ini:mov.l	fp,@-sp
	mov.l	sp,fp
	mov.w	r0,@-sp
;/;
;/; MSTCR.3:=0
;/;
;/	mov.l	#mstcr,r0
;/	bclr	#3,@r0
; scr1:=$00;   { for initialize }
	xor.b	r0,r0
	mov.b	r0,sci1scr
; smr1:=$60;   { 7bit even 1 stop }
;	mov.b	#h'60,r0
	mov.b	@(8,fp),r0	; smr data
	and.b	#h'73,r0
	mov.b	r0,sci1smr
; brr1:=bps;  
	mov.w	@(9,fp),r0	; brr data
	mov.b	r0,sci1brr
;
; wait sci1 setup
;
	mov.w	#1000,r0
$1:	dec.w	#1,r0
	bne	$1
; flushaux1;
	bsr	flushaux1
; scr1:=$70;   { rxi,txen,rxen }
	mov.b	#h'70,r0	; rxi,txen,rxen for int
	mov.b	r0,sci1scr
; iprb:=$04
; ccr.i:=1
; ccr.ui:=0
	mov.l	#iprb,r0
	bset	#2,@r0		; int level
	ldc.b	#h'80,ccr	; ei
; end; {sci1ini}
	mov.w	@sp+,r0
	mov.l	fp,sp
	mov.l	@(4,sp),fp
	mov.l	fp,@(4+2,sp)
	mov.l	@sp+,fp
	adds	#2,sp
	rts
;
;=================================
;==  ( public )               * ==
;==  flush sci 1                ==
;==                             ==
;=================================
;* 
;* procedure flushraux;
;*
flushaux1:
	xor.l	r0,r0
	mov.l	r0,putrcvp1
	mov.l	r0,getrcvp1
	mov.w	r0,rcvcnt1
	rts
;
	end
